ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.7 by root, Tue Dec 7 13:23:07 2010 UTC vs.
Revision 1.75 by root, Tue Aug 1 03:48:59 2023 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9DLCACHE=
10MKBUNDLE="$STATICPERL/mkbundle"
11 10
12# perl build variables 11# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 12MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 13PERL_VERSION=http://stableperl.schmorp.de/dist/latest.tar.gz # 5.12.5 and 5.8.9 are good choices for small builds
14PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os" # -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 18
19ARCH="$(uname -m)" 19ARCH="$(uname -m)"
20 20
21case "$ARCH" in 21#case "$ARCH" in
22 i*86 | x86_64 | amd64 ) 22# i*86 | x86_64 | amd64 )
23 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 23# PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
24 case "$ARCH" in 24# case "$ARCH" in
25 i*86 ) 25# i*86 )
26 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 26# PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
27 ;; 27# ;;
28 esac 28# esac
29 ;; 29# ;;
30esac 30#esac
31 31
32# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LDFLAGS=
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 37PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 38
38# some configuration options for modules 39# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
41PERL_MM_OPT="MAN1PODS= MAN3PODS="
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
44export PERL_MM_USE_DEFAULT PERL_MM_OPT
42 45
43# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
44# required by mkbundle 47# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="ExtUtils::MakeMaker ExtUtils::CBuilder common::sense Pod::Strip PPI PPI::XS Pod::Usage"
46 49
47# which extra modules you might want to install 50# which extra modules you might want to install
48EXTRA_MODULES="" 51EXTRA_MODULES=""
49 52
50# overridable functions 53# overridable functions
51preconfigure() { : ; } 54preconfigure() { : ; }
55patchconfig() { : ; }
52postconfigure() { : ; } 56postconfigure() { : ; }
53postbuild() { : ; } 57postbuild() { : ; }
58postcpanconfig() { : ; }
54postinstall() { : ; } 59postinstall() { : ; }
55 60
56# now source user config, if any 61# now source user config, if any
62if [ "$STATICPERLRC" ]; then
63 . "$STATICPERLRC"
64else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 65 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 66 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 67 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
68fi
60 69
61############################################################################# 70#############################################################################
62# support 71# support
63 72
73# work around ExtUtils::CBuilder and others
74export CC="$PERL_CC"
75export CFLAGS="$PERL_CFLAGS"
76export LD="$PERL_CC"
77export LDFLAGS="$PERL_LDFLAGS"
78unset LIBS
79
80PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
81
82unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
83unset PERL_MB_OPT
84LC_ALL=C; export LC_ALL # just to be on the safe side
85
86# prepend PATH - not required by staticperl itself, but might make
87# life easier when working in e.g. "staticperl cpan / look"
88PATH="$PERL_PREFIX/perl/bin:$PATH"
89
64# set version in a way that Makefile.PL can extract 90# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 91VERSION=VERSION; eval \
66$VERSION=0.1 92$VERSION="1.46"
67
68BZ2=bz2
69BZIP2=bzip2
70 93
71fatal() { 94fatal() {
72 printf -- "\nFATAL: %s\n\n" "$*" >&2 95 printf -- "\nFATAL: %s\n\n" "$*" >&2
73 exit 1 96 exit 1
74} 97}
104############################################################################# 127#############################################################################
105# clean 128# clean
106 129
107distclean() { 130distclean() {
108 verblock <<EOF 131 verblock <<EOF
109deleting everything installed by this script 132 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 133EOF
111 134
112 rm -rf "$STATICPERL" 135 rm -rf "$STATICPERL"
113} 136}
114 137
115############################################################################# 138#############################################################################
116# download/configure/compile/install perl 139# download/configure/compile/install perl
117 140
118clean() { 141clean() {
119 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 142 rm -rf "$STATICPERL/src"
143}
144
145realclean() {
146 rm -f "$PERL_PREFIX/staticstamp.postinstall"
147 rm -f "$PERL_PREFIX/staticstamp.install"
148 rm -f "$STATICPERL/src/perl/staticstamp.configure"
120} 149}
121 150
122fetch() { 151fetch() {
152(
123 rcd "$STATICPERL" 153 rcd "$STATICPERL"
124 154
125 mkdir -p src 155 mkdir -p src
126 rcd src 156 rcd src
127 157
128 if ! [ -d "perl-$PERL_VERSION" ]; then 158 if ! [ -d "perl" ]; then
129 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 159 rm -rf unpack
160 mkdir -p unpack
130 161
162 case "$PERL_VERSION" in
163 *:* )
164 # url
165 PERLURL="$PERL_VERSION"
166 PERLTAR="$(basename "$PERL_VERSION")"
167 ;;
168 /* )
169 # directory
170 verbose "copying $PERL_VERSION"
171 cp -Rp "$PERL_VERSION/." unpack/.
172 chmod -R u+w unpack
173 mv unpack perl
174 return
175 ;;
176 * )
131 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 177 PERLURL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.bz2"
178 PERLTAR=perl-$PERL_VERSION.tar.bz2
179 ;;
180 esac
132 181
182 if ! [ -e "$PERLTAR" ]; then
133 verblock <<EOF 183 verblock <<EOF
134downloading perl 184downloading perl
185
186trying to download from $PERLURL
187
188you can configure a download cache directory via DLCACHE
189in your .staticperlrc to avoid repeated downloads.
190
135to manually download perl yourself, place 191to manually download perl yourself, place a suitable tarball in
136perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 192$DLCACHE/$PERLTAR
137trying $URL
138EOF
139 193
194either curl or wget is required for automatic download.
195curl is tried first, then wget.
196EOF
197
140 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 198 rm -f $PERLTAR~ # just to be on the safe side
141 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 199 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
142 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 200 || wget -O $PERLTAR~ "$PERLURL" \
201 || curl -f >$PERLTAR~ "$PERLURL" \
143 || fatal "$URL: unable to download" 202 || fatal "$URL: unable to download"
144 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 203 rm -f $PERLTAR
204 mv $PERLTAR~ $PERLTAR
205 if [ "$DLCACHE" ]; then
206 mkdir -p "$DLCACHE"
207 cp $PERLTAR "$DLCACHE"/$PERLTAR~$$~ && \
208 mv "$DLCACHE"/$PERLTAR~$$~ "$DLCACHE"/$PERLTAR
209 fi
145 fi 210 fi
146 211
147 verblock <<EOF 212 verblock <<EOF
148unpacking perl 213unpacking perl
149EOF 214EOF
150 215
151 mkdir -p unpack 216 case "$PERLTAR" in
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xpC unpack \ 217 *.xz ) UNCOMPRESS="xz -d" ;;
218 *.lzma ) UNCOMPRESS="lzma -d" ;;
219 *.bz2 ) UNCOMPRESS="bzip2 -d" ;;
220 *.gz ) UNCOMPRESS="gzip -d" ;;
221 *.tar ) UNCOMPRESS="cat" ;;
222 * )
223 fatal "don't know hot to uncompress $PERLTAR,\nonly tar, tar.gz, tar.bz2, tar.lzma and tar.xz are supported."
224 exit 1
225 ;;
226 esac
227
228 <"$PERLTAR" $UNCOMPRESS -d | ( cd unpack && tar xf - ) \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 229 || fatal "$PERLTAR: error during unpacking"
154 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 230
231 if [ -d unpack/*/ ]; then
232 chmod -R u+w unpack/*/
233 mv unpack/*/ perl
155 rmdir -p unpack 234 rmdir -p unpack
235 else
236 fatal "unpacking $PERLTAR did not result in a single directory, don't know how to handle this"
237 fi
238
239 rm "$PERLTAR"
156 fi 240 fi
241) || exit
157} 242}
158 243
159# similar to GNU-sed -i or perl -pi 244# similar to GNU-sed -i or perl -pi
160sedreplace() { 245sedreplace() {
161 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 246 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
247 rm -f "$2"
162 mv "$2~" "$2" 248 mv "$2~" "$2"
163} 249}
164 250
251configure_failure() {
252 cat <<EOF
253
254
255***
256*** Configure failed - see above for the exact error message(s).
257***
258*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
259*** flags are not supported by your compiler. Less often, this is because
260*** PERL_LIBS either contains a library not available on your system (such as
261*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
262***
263*** You can provide your own flags by creating a ~/.staticperlrc file with
264*** variable assignments. For example (these are the actual values used):
265***
266
267PERL_CC="$PERL_CC"
268PERL_CCFLAGS="$PERL_CCFLAGS"
269PERL_OPTIMIZE="$PERL_OPTIMIZE"
270PERL_LDFLAGS="$PERL_LDFLAGS"
271PERL_LIBS="$PERL_LIBS"
272
273EOF
274 exit 1
275}
276
165configure() { 277configure() {
278(
166 fetch 279 fetch
167 280
168 rcd "$STATICPERL/src/perl-$PERL_VERSION" 281 rcd "$STATICPERL/src/perl"
169 282
170 [ -e staticstamp.configure ] && return 283 [ -e staticstamp.configure ] && return
171 284
172 verblock <<EOF 285 verblock <<EOF
173configuring $STATICPERL/src/perl-$PERL_VERSION 286configuring $STATICPERL/src/perl
174EOF 287EOF
175
176 clean
177 288
178 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
179 290
291 "$MAKE" distclean >/dev/null 2>&1
292
293 sedreplace '/^#define SITELIB/d' config_h.SH
294
180 # I hate them 295 # I hate them for this
181 grep -q -- -fstack-protector Configure && \ 296 grep -q -- -fstack-protector Configure && \
182 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 297 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
183 298
184 preconfigure 299 # what did that bloke think
300 grep -q -- usedl=.define hints/darwin.sh && \
301 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
302
303 preconfigure || fatal "preconfigure hook failed"
185 304
186# trace configure \ 305# trace configure \
187 sh Configure -Duselargefiles \ 306 sh Configure -Duselargefiles \
188 -Uuse64bitint \ 307 -Uuse64bitint \
189 -Dusemymalloc=n \ 308 -Dusemymalloc=n \
190 -Uusedl \ 309 -Uusedl \
191 -Uusethreads \ 310 -Uusethreads \
192 -Uuseithreads \ 311 -Uuseithreads \
193 -Uusemultiplicity \ 312 -Uusemultiplicity \
194 -Duseperlio \
195 -Uusesfio \ 313 -Uusesfio \
196 -Uuseshrplib \ 314 -Uuseshrplib \
315 -Uinstallusrbinperl \
197 -Dcppflags="$PERL_CPPFLAGS" \ 316 -A ccflags=" $PERL_CCFLAGS" \
198 -Dccflags="-g2 -fno-strict-aliasing" \ 317 -Dcc="$PERL_CC" \
199 -Doptimize="$PERL_OPTIMIZE" \ 318 -Doptimize="$PERL_OPTIMIZE" \
200 -Dldflags="$PERL_LDFLAGS" \ 319 -Dldflags="$PERL_LDFLAGS" \
201 -Dlibs="$PERL_LIBS" \ 320 -Dlibs="$PERL_LIBS" \
202 -Dprefix="$PERL_PREFIX" \ 321 -Dprefix="$PERL_PREFIX" \
203 -Dbin="$PERL_PREFIX/bin" \ 322 -Dbin="$PERL_PREFIX/bin" \
204 -Dprivlib="$PERL_PREFIX/lib" \ 323 -Dprivlib="$PERL_PREFIX/lib" \
205 -Darchlib="$PERL_PREFIX/lib" \ 324 -Darchlib="$PERL_PREFIX/lib" \
206 -Uusevendorprefix \ 325 -Uusevendorprefix \
207 -Dsitelib="$PERL_PREFIX/lib" \ 326 -Dsitelib="$PERL_PREFIX/lib" \
208 -Dsitearch="$PERL_PREFIX/lib" \ 327 -Dsitearch="$PERL_PREFIX/lib" \
209 -Usitelibexp \
210 -Uman1dir \ 328 -Uman1dir \
211 -Uman3dir \ 329 -Uman3dir \
212 -Usiteman1dir \ 330 -Usiteman1dir \
213 -Usiteman3dir \ 331 -Usiteman3dir \
214 -Dpager=/usr/bin/less \ 332 -Dpager=/usr/bin/less \
215 -Demail="$EMAIL" \ 333 -Demail="$EMAIL" \
216 -Dcf_email="$EMAIL" \ 334 -Dcf_email="$EMAIL" \
217 -Dcf_by="$EMAIL" \ 335 -Dcf_by="$EMAIL" \
218 $PERL_CONFIGURE \ 336 $PERL_CONFIGURE \
337 -Duseperlio \
338 -Uversiononly \
219 -dE || fatal "Configure failed" 339 -dE || configure_failure
220 340
221 sedreplace ' 341 sedreplace '
222 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 342 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
223 s/ *-fno-stack-protector */ /g 343 s/ *-fno-stack-protector */ /g
224 ' config.sh 344 ' config.sh
225 345
346 patchconfig || fatal "patchconfig hook failed"
347
226 sh Configure -S || fatal "Configure -S failed" 348 sh Configure -S || fatal "Configure -S failed"
227 349
228 postconfigure || fatal "postconfigure hook failed" 350 postconfigure || fatal "postconfigure hook failed"
229 351
230 touch staticstamp.configure 352 : > staticstamp.configure
353) || exit
354}
355
356write_shellscript() {
357 {
358 echo "#!/bin/sh"
359 echo "STATICPERL=\"$STATICPERL\""
360 echo "PERL_PREFIX=\"$PERL_PREFIX\""
361 echo "MAKE=\"$MAKE\""
362 cat
363 } >"$PERL_PREFIX/bin/$1"
364 chmod 755 "$PERL_PREFIX/bin/$1"
231} 365}
232 366
233build() { 367build() {
368(
234 configure 369 configure
235 370
236 rcd "$STATICPERL/src/perl-$PERL_VERSION" 371 rcd "$STATICPERL/src/perl"
237 372
238 verblock <<EOF 373 verblock <<EOF
239building $STATICPERL/src/perl-$PERL_VERSION 374building $STATICPERL/src/perl
240EOF 375EOF
241 376
242 rm -f "$PERL_PREFIX/staticstamp.install" 377 rm -f "$PERL_PREFIX/staticstamp.install"
243 378
244 make || fatal "make: error while building perl" 379 "$MAKE" || fatal "make: error while building perl"
245 380
246 postbuild || fatal "postbuild hook failed" 381 postbuild || fatal "postbuild hook failed"
382) || exit
383}
384
385_postinstall() {
386 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
387 NOCHECK_INSTALL=+
388 instcpan $STATICPERL_MODULES
389 [ "$EXTRA_MODULES" ] && instcpan $EXTRA_MODULES
390
391 postinstall || fatal "postinstall hook failed"
392
393 : > "$PERL_PREFIX/staticstamp.postinstall"
394 fi
247} 395}
248 396
249install() { 397install() {
398(
250 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 399 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
251
252 build 400 build
253 401
254 verblock <<EOF 402 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 403installing $STATICPERL/src/perl
256to $PERL_PREFIX 404to $PERL_PREFIX
257EOF 405EOF
258 406
259 rm -rf "$PERL_PREFIX" 407 ln -sf "perl/bin/" "$STATICPERL/bin"
260 408 ln -sf "perl/lib/" "$STATICPERL/lib"
409
410 mkdir "$STATICPERL/patched"
411
412 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
413 rm -rf "$PERL_PREFIX" # by this rm -rf
414
415 rcd "$STATICPERL/src/perl"
416
261 make install || fatal "make install: error while installing" 417 "$MAKE" install || fatal "make install: error while installing"
262 418
263 rcd "$PERL_PREFIX" 419 rcd "$PERL_PREFIX"
264 420
265 # create a "make install" replacement for CPAN 421 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 422 write_shellscript SP-make-make <<'end_of_make'
267make install UNINST=1 423#CAT make-make.sh
268if find blib/arch/auto -type f | grep -q -v .exists; then 424end_of_make
269 echo Probably an XS module, rebuilding perl
270 make perl
271 rm -f "$PERL_PREFIX"/bin/perl
272 make -f Makefile.aperl inst_perl
273 make -f Makefile.aperl map_clean
274fi
275EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 425
426 # create a "make install" replacement for CPAN
427 write_shellscript SP-make-install-make <<'end_of_make_install_make'
428#CAT make-install-make.sh
429end_of_make_install_make
430
431 # create a "patch modules" helper
432 write_shellscript SP-patch-postinstall <<'end_of_patch_postinstall'
433#CAT patch-postinstall.sh
434end_of_patch_postinstall
435
436 # immediately use it
437 "$PERL_PREFIX/bin/SP-patch-postinstall"
438
278 # trick CPAN into avoiding ~/.cpan completely 439 # help to trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 440 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
280 441
442 # we call cpan with -MCPAN::MyConfig in this script, which
443 # is strictly unnecessary as we have to patch CPAN anyway,
444 # so consider it "for good measure".
281 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 445 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
282 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 446 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
447 CPAN::Shell->o (conf => pushy_https => "0");
283 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 448 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
284 CPAN::Shell->o (conf => q<init>); 449 CPAN::Shell->o (conf => q<init>);
285 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 450 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
286 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 451 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
287 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 452 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
288 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 453 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
289 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 454 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
455 CPAN::Shell->o (conf => q<makepl_arg>, "MAP_TARGET=perl");
456 CPAN::Shell->o (conf => q<make>, "'"$PERL_PREFIX"'/bin/SP-make-make");
290 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 457 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
291 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 458 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
292 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 459 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<yes>);
460 CPAN::Shell->o (conf => q<recommends_policy>, q<0>);
461 CPAN::Shell->o (conf => q<suggests_policy>, q<0>);
462 CPAN::Shell->o (conf => q<prefer_installer>, q<EUMM>);
293 CPAN::Shell->o (conf => q<commit>); 463 CPAN::Shell->o (conf => q<commit>);
294 ' || fatal "error while initialising CPAN" 464 ' || fatal "error while initialising CPAN"
295 465
296 NOCHECK_INSTALL=+ 466 postcpanconfig
297 instcpan $STATICPERL_MODULES
298 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
299 467
300 postinstall || fatal "postinstall hook failed"
301
302 touch "$PERL_PREFIX/staticstamp.install" 468 : > "$PERL_PREFIX/staticstamp.install"
469 fi
470
471 _postinstall
472) || exit
473}
474
475import() {
476(
477 IMPORT="$1"
478
479 rcd "$STATICPERL"
480
481 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
482 verblock <<EOF
483import perl from $IMPORT to $STATICPERL
484EOF
485
486 rm -rf bin cpan lib patched perl src
487 mkdir -m 755 perl perl/bin
488 ln -s perl/bin/ bin
489 ln -s "$IMPORT" perl/bin/
490
491 echo "$IMPORT" > "$PERL_PREFIX/.import"
492
493 : > "$PERL_PREFIX/staticstamp.install"
494 fi
495
496 _postinstall
497) || exit
303} 498}
304 499
305############################################################################# 500#############################################################################
306# install a module from CPAN 501# install a module from CPAN
307 502
308instcpan() { 503instcpan() {
309 [ $NOCHECK_INSTALL ] || install 504 [ $NOCHECK_INSTALL ] || install
310 505
311 verblock <<EOF 506 verblock <<EOF
312installing modules from CPAN 507installing modules from CPAN
313$@ 508$*
314EOF 509EOF
315 510
316 for mod in "$@"; do 511 MYCONFIG=
317 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 512 [ -e "$PERL_PREFIX/.import" ] || MYCONFIG=-MCPAN::MyConfig
318 || fatal "$mod: unable to install from CPAN" 513
319 done 514 "$PERL_PREFIX"/bin/perl $MYCONFIG -MCPAN -e 'notest (install => $_) for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
515
516 if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
517 fatal "failure while installing modules from CPAN ($*)"
518 fi
320 rm -rf "$STATICPERL/build" 519 rm -f "$STATICPERL/instcpan.log"
321} 520}
322 521
323############################################################################# 522#############################################################################
324# install a module from unpacked sources 523# install a module from unpacked sources
325 524
326instsrc() { 525instsrc() {
327 [ $NOCHECK_INSTALL ] || install 526 [ $NOCHECK_INSTALL ] || install
328 527
329 verblock <<EOF 528 verblock <<EOF
330installing modules from source 529installing modules from source
331$@ 530$*
332EOF 531EOF
333 532
334 for mod in "$@"; do 533 for mod in "$@"; do
335 echo 534 echo
336 echo $mod 535 echo $mod
337 ( 536 (
338 rcd $mod 537 rcd $mod
339 make -f Makefile.aperl map_clean >/dev/null 2>&1 538 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
340 make distclean >/dev/null 2>&1 539 "$MAKE" distclean >/dev/null 2>&1
341 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 540 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
342 make || fatal "$mod: error building module" 541 "$MAKE" || fatal "$mod: error building module"
343 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 542 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
344 make distclean >/dev/null 2>&1 543 "$MAKE" distclean >/dev/null 2>&1
345 exit 0 544 exit 0
346 ) || exit $? 545 ) || exit $?
347 done 546 done
348} 547}
349 548
350############################################################################# 549#############################################################################
351# main 550# main
352 551
353podusage() { 552podusage() {
354 echo 553 echo
554
355 if [ -e "$PERL_PREFIX/bin/perl" ]; then 555 if [ -e "$PERL_PREFIX/bin/perl" ]; then
356 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 556 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
357 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 557 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
358 2>/dev/null && exit 558 2>/dev/null && exit
359 fi 559 fi
560
360 # try whatever perl we can find 561 # try whatever perl we can find
361 perl -MPod::Usage -e \ 562 perl -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 563 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 564 2>/dev/null && exit
364 565
365 fatal "displaying documentation requires a working perl - try '$0 install' first" 566 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
366} 567}
367 568
368usage() { 569usage() {
369 podusage 0 570 podusage 0
370} 571}
372catmkbundle() { 573catmkbundle() {
373 { 574 {
374 read dummy 575 read dummy
375 echo "#!$PERL_PREFIX/bin/perl" 576 echo "#!$PERL_PREFIX/bin/perl"
376 cat 577 cat
377 } <<'MKBUNDLE' 578 } <<'end_of_mkbundle'
378#CAT mkbundle 579#CAT mkbundle
379MKBUNDLE 580end_of_mkbundle
380} 581}
381 582
382bundle() { 583bundle() {
584 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
383 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 585 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
384 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 586 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
587 CACHE="$STATICPERL/cache"
588 mkdir -p "$CACHE"
385 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 589 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
386} 590}
387 591
388if [ $# -gt 0 ]; then 592if [ $# -gt 0 ]; then
389 while [ $# -gt 0 ]; do 593 while [ $# -gt 0 ]; do
390 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 594 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
391 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 595 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
392 596
393 command="${1#--}"; shift 597 command="${1#--}"; shift
394 case "$command" in 598 case "$command" in
599 version )
600 echo "staticperl version $VERSION"
601 ;;
395 fetch | configure | build | install | clean | distclean) 602 fetch | configure | build | install | clean | realclean | distclean )
396 verblock <<EOF
397$command
398EOF
399 ( "$command" ) 603 ( "$command" ) || exit
604 ;;
605 import )
606 ( import "$1" ) || exit
607 shift
400 ;; 608 ;;
401 instsrc ) 609 instsrc )
402 ( instsrc "$@" ) 610 ( instsrc "$@" ) || exit
403 exit 611 exit
404 ;; 612 ;;
405 instcpan ) 613 instcpan )
406 ( instcpan "$@" ) 614 ( instcpan "$@" ) || exit
407 exit 615 exit
408 ;; 616 ;;
617 perl )
618 ( install ) || exit
619 exec "$PERL_PREFIX/bin/perl" "$@"
620 exit
621 ;;
409 cpan ) 622 cpan )
410 ( install ) 623 ( install ) || exit
624 PERL="$PERL_PREFIX/bin/perl"
625 export PERL
411 "$PERL_PREFIX/bin/cpan" "$@" 626 exec "$PERL_PREFIX/bin/cpan" "$@"
412 exit 627 exit
413 ;; 628 ;;
414 mkbundle ) 629 mkbundle )
415 ( install ) 630 ( install ) || exit
416 bundle "$@" 631 bundle "$@"
417 exit 632 exit
418 ;; 633 ;;
419 mkperl ) 634 mkperl )
420 ( install ) 635 ( install ) || exit
421 bundle --perl "$@" 636 bundle --perl "$@"
637 exit
638 ;;
639 mkapp )
640 ( install ) || exit
641 bundle --app "$@"
422 exit 642 exit
423 ;; 643 ;;
424 help ) 644 help )
425 podusage 2 645 podusage 2
426 ;; 646 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines